SystemOrganization addCategory: #'Seaside-Squeak-Development-Core'!
SystemOrganization addCategory: #'Seaside-Squeak-Development-Core-Plugins'!

WAToolPlugin subclass: #WAMemoryToolPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Squeak-Development-Core-Plugins'!

!WAMemoryToolPlugin commentStamp: 'pmm 5/27/2007 18:32' prior: 0!
I display the memory usage tool.!

!WAMemoryToolPlugin methodsFor: 'actions' stamp: 'lr 5/11/2007 13:56'!
execute
	self open: (WAMemory new root: self target)! !

!WAMemoryToolPlugin methodsFor: 'accessing' stamp: 'lr 5/11/2007 00:24'!
label
	^ 'Memory'! !

!WAMemoryToolPlugin methodsFor: 'accessing' stamp: 'lr 5/11/2007 10:56'!
priority
	^ 500! !

WAToolPlugin subclass: #WAProfilerToolPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Squeak-Development-Core-Plugins'!

!WAProfilerToolPlugin commentStamp: 'pmm 5/27/2007 18:32' prior: 0!
I display the rendering profiler.!

!WAProfilerToolPlugin methodsFor: 'actions' stamp: 'lr 5/11/2007 13:53'!
execute
	self open: (WAProfiler new root: self target)! !

!WAProfilerToolPlugin methodsFor: 'accessing' stamp: 'lr 5/11/2007 00:27'!
label
	^ 'Profiler'! !

!WAProfilerToolPlugin methodsFor: 'accessing' stamp: 'lr 5/11/2007 10:56'!
priority
	^ 400! !

WAComponent subclass: #WABrowser
	instanceVariableNames: 'contents model message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Squeak-Development-Core'!

!WABrowser class methodsFor: 'accessing' stamp: 'pmm 4/1/2008 07:05'!
applicationName
	"needed for RSRSS"
	^'tools/classbrowser'! !

!WABrowser class methodsFor: 'accessing' stamp: 'lr 1/8/2008 20:14'!
canBeRoot
	^ true! !

!WABrowser class methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:18'!
description
	^ 'Smalltalk Code Browser'! !

!WABrowser class methodsFor: 'instance-creation' stamp: 'lr 11/3/2006 13:50'!
fullOnClass: aClass
	^ self fullOnClass: aClass selector: nil! !

!WABrowser class methodsFor: 'instance-creation' stamp: 'lr 11/3/2006 13:50'!
fullOnClass: aClass selector: aSelector
	^ self new model: (Browser new setClass: aClass selector: aSelector)! !

!WABrowser class methodsFor: 'initialization' stamp: 'lr 5/31/2008 18:32'!
initialize
	self registerAsApplication: self applicationName! !

!WABrowser methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
accept
	| save |
	SeasidePlatformSupport ensureAuthorInitials: [self request: 'Please enter your initials:'].
	message := nil.
	save := contents.
	model contents: contents notifying: self.
	contents := save! !

!WABrowser methodsFor: 'accessing' stamp: 'lr 8/1/2007 11:15'!
columns
	^ #( systemCategory class messageCategory message )! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:50'!
contents
	^contents! !

!WABrowser methodsFor: 'accessing' stamp: 'pmm 4/12/2008 22:49'!
contents: aString
	"the browser sends CRLF as line ending but Squeak wants CR"
	contents := SeasidePlatformSupport convertToSmalltalkNewlines: aString! !

!WABrowser methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
initialRequest: aRequest
	| theClass |
	super initialRequest: aRequest.
	aRequest fields at: 'class' ifPresent:
		[:className |
		Smalltalk at: className asSymbol ifPresent:
			[:class |
			theClass := (aRequest fields includesKey: 'meta')
					ifTrue: [class class]
					ifFalse: [class].
			self model setClass: theClass selector: nil.
			aRequest fields at: 'method' ifPresent:
				[:selector |
				self model setClass: theClass selector: selector asSymbol]]]! !

!WABrowser methodsFor: 'initialization' stamp: 'lr 5/28/2007 18:09'!
initialize
	super initialize.
	self model: Browser new! !

!WABrowser methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
model
	^model! !

!WABrowser methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:55'!
model: aBrowserModel
	model := aBrowserModel.
	model addDependent: self.
	contents := model contents! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:36'!
notify: aString at: location in: sourceStream
	message := aString allButLast: 3! !

!WABrowser methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderColumnsOn: html
	html div class: 'columns'; with: [
		self columns do: [ :each |
			html form class: 'column'; with: [
				| array |
				array := self model perform: (each , 'List') asSymbol.
				html select
					size: 10;
					beSubmitOnChange;
					list: array;
					selected: (array
						at: (self model perform: (each , 'ListIndex') asSymbol)
						ifAbsent: []);
					callback: [ :item |
						self model
							perform: (each , 'ListIndex:') asSymbol
							with: (array indexOf: item) ] ] ] ]! !

!WABrowser methodsFor: 'rendering' stamp: 'lr 4/9/2008 10:58'!
renderContentOn: html
	self
		renderColumnsOn: html;
		renderModeButtonsOn: html;
		renderMessageOn: html;
		renderContentPaneOn: html! !

!WABrowser methodsFor: 'rendering' stamp: 'lr 8/6/2007 09:46'!
renderContentPaneOn: html
	html form class: 'definition'; with: [
		html textArea on: #contents of: self.
		html break.
		html submitButton on: #accept of: self ]! !

!WABrowser methodsFor: 'rendering' stamp: 'lr 11/16/2006 15:35'!
renderMessageOn: html
	message ifNotNil: [ html strong: message ]! !

!WABrowser methodsFor: 'rendering' stamp: 'lr 8/6/2007 09:44'!
renderModeButtonsOn: html
	html form class: 'mode'; with: [
		html submitButton
			callback: [ self showInstance ];
			value: 'instance'.
		html submitButton
			callback: [ self showHelp ];
			value: 'help'.
		html submitButton
			callback: [ self showClass ];
			value: 'class' ]! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
select! !

!WABrowser methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
selectFrom: aPos to: anotherPos! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:44'!
selectionInterval
	^ 1 to: 1! !

!WABrowser methodsFor: 'actions' stamp: 'LR 9/13/2002 20:38'!
showClass
	self model indicateClassMessages! !

!WABrowser methodsFor: 'actions' stamp: 'LR 9/13/2002 20:42'!
showHelp
	self model plusButtonHit! !

!WABrowser methodsFor: 'actions' stamp: 'LR 9/13/2002 20:39'!
showInstance
	self model indicateInstanceMessages! !

!WABrowser methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:55'!
states
	^ Array with: model! !

!WABrowser methodsFor: 'rendering' stamp: 'lr 8/6/2007 09:51'!
style
	^ 'form, div.columns {
	padding: 2px;
	margin: 0;
}

form.column {
	padding: 0;
	width: 25%;
	float: left;
}
form.column select {
	width: 100%;
	border: 1px solid #aaa;
}

form.mode {
	clear: both;
}

form.definition textarea {
	width: 100%;
	height: 200px;
	border: 1px solid #aaa;
}'! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:44'!
text
	^ Text fromString: ''! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 01:45'!
update: aSymbol
	contents := model contents! !

!WABrowser methodsFor: 'processing' stamp: 'lr 2/12/2008 08:11'!
updateUrl: aUrl
	super updateUrl: aUrl.
	self model selectedClass isNil ifFalse: [
		aUrl addParameter: 'class' value: self model selectedClass fullName.
		self model metaClassIndicated
			ifTrue: [ aUrl addParameter: 'meta' ] ].
	self model selectedMessageName isNil 
		ifFalse: [ aUrl addParameter: 'method' value: self model selectedMessageName ]! !

WAComponent subclass: #WAScreenshot
	instanceVariableNames: 'button zoom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Squeak-Development-Core'!

!WAScreenshot class methodsFor: 'accessing' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

!WAScreenshot class methodsFor: 'accessing' stamp: 'lr 6/10/2007 20:26'!
description
	^ 'Squeak Screenshot'! !

!WAScreenshot class methodsFor: 'initialization' stamp: 'lr 2/12/2007 21:53'!
initialize
	self registerAsApplication: 'tools/screenshot'! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:48'!
buttonCode
	^ button = #red
		ifTrue: [ 4 ]
		ifFalse: [
			button = #blue
				ifTrue: [ 2 ]
				ifFalse: [ 1 ] ]! !

!WAScreenshot methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
click: aPoint
	| event |
	event := Sensor createMouseEvent.
	event at: 3 put: aPoint x.
	event at: 4 put: aPoint y.
	event at: 5 put: self buttonCode.
	Sensor processEvent: event.
	event at: 5 put: 0.
	Sensor processEvent: event.
	button := #red! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:48'!
form
	^ zoom
		ifFalse: [ Display copy ]
		ifTrue: [ self topWindow imageForm ]! !

!WAScreenshot methodsFor: 'initialize-release' stamp: 'pmm 9/20/2006 17:45'!
initialize
	super initialize.
	button := #red.
	zoom := false! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 9/20/2006 17:49'!
offset
	^ zoom
		ifTrue: [ self topWindow position ]
		ifFalse: [ 0@0 ]! !

!WAScreenshot methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html table: [
		html tableRow: [
			html tableData: [ self renderMouseButtonOn: html ].
			html tableData: [ self renderToggleZoomOn: html ].
			html tableData: [ self renderToggleUIProcessOn: html ] ] ].
	self renderMouseClickOn: html.
	html horizontalRule! !

!WAScreenshot methodsFor: 'rendering' stamp: 'pmm 4/26/2007 23:47'!
renderMouseButtonOn: html
	| group |
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'Button: '.
				group := html radioGroup.
				#(red yellow blue) do: [ :each |
					html tableData
						style: 'background-color: ' , each;
						with: [
							group radioButton
								selected: button = each;
								callback: [ button := each] ] ].
				html tableData: [
					html submitButton text: 'Set'] ] ] ]! !

!WAScreenshot methodsFor: 'rendering' stamp: 'pmm 6/21/2007 21:40'!
renderMouseClickOn: html
	html div: [
		html map
			id: #pictureMap;
			title: 'Click here';
			callback: [ :point | self click: point + self offset];
			with: [
				html image
					form: self form ] ]! !

!WAScreenshot methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderToggleUIProcessOn: html
	html anchor callback: [self toggleUIProcess]; with: self toggleUIText! !

!WAScreenshot methodsFor: 'rendering' stamp: 'pmm 11/1/2007 21:42'!
renderToggleZoomOn: html
	html anchor
		callback: [ self toggleZoom ];
		with: self toggleZoomText! !

!WAScreenshot methodsFor: 'actions' stamp: 'pmm 11/1/2007 21:42'!
toggleUIProcess
	Project uiProcess isSuspended
		ifTrue: [ Project uiProcess resume ]
		ifFalse: [ Project uiProcess suspend ]! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 11/1/2007 21:41'!
toggleUIText
	^ Project uiProcess isSuspended
		ifFalse: [ 'Suspend UI Process' ]
		ifTrue: [ 'Resume UI Process' ]! !

!WAScreenshot methodsFor: 'actions' stamp: 'pmm 9/20/2006 17:47'!
toggleZoom
	zoom := zoom not! !

!WAScreenshot methodsFor: 'accessing' stamp: 'pmm 11/1/2007 21:42'!
toggleZoomText
	^ zoom
		ifTrue: [ 'Zoom out' ]
		ifFalse: [ 'Zoom in' ]! !

!WAScreenshot methodsFor: 'accessing' stamp: 'avi 2/5/2004 14:18'!
topWindow
	^ SystemWindow classPool at: #TopWindow! !

WAComponent subclass: #WAVNCController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Squeak-Development-Core'!

!WAVNCController class methodsFor: 'accessing' stamp: 'lr 2/12/2007 21:53'!
canBeRoot
	^ true! !

!WAVNCController class methodsFor: 'accessing' stamp: 'lr 6/10/2007 20:26'!
description
	^ 'VNC Controller'! !

!WAVNCController class methodsFor: 'initialization' stamp: 'lr 1/8/2008 20:14'!
initialize
	(Smalltalk hasClassNamed: #RFBServer)
		ifTrue: [ self registerAsApplication: 'tools/vnc' ]! !

!WAVNCController methodsFor: 'accessing' stamp: 'pmm 11/20/2007 15:49'!
currentDisplay
	^ self serverInstance displayNumber toString! !

!WAVNCController methodsFor: 'testing' stamp: 'pmm 3/6/2007 21:54'!
isServerRunning
	^self serverInstance notNil! !

!WAVNCController methodsFor: 'accessing' stamp: 'lr 11/21/2006 00:02'!
project
	^ Smalltalk classNamed: #Project! !

!WAVNCController methodsFor: 'rendering' stamp: 'pmm 3/6/2007 21:54'!
renderContentOn: html
	html heading: 'VNC Server'.
	self isServerRunning
		ifTrue: [ self renderStopOn: html ]
		ifFalse: [ self renderStartOn: html ].
	html heading: 'UI Process'.
	self project uiProcess isSuspended
		ifFalse: [ self renderSuspendOn: html ]
		ifTrue: [ self renderResumeOn: html ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:01'!
renderResumeOn: html
	html form: [
		html text: 'UI Process is suspended. '.
		html submitButton
			callback: [ self resume ];
			text: 'Resume' ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'pmm 12/9/2007 12:28'!
renderStartOn: html
	html form: [
		html text: 'Start VNC on display: '.
		html textInput
			value: 0;
			callback: [ :value | self startOn: value asInteger ].
		html submitButton
			text: 'Start' ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:01'!
renderStopOn: html
	html form: [
		html text: 'Stop VNC (running on ', self currentDisplay, ') '.
		html submitButton
			callback: [ self stop ];
			text: 'Stop' ]! !

!WAVNCController methodsFor: 'rendering' stamp: 'lr 11/21/2006 00:01'!
renderSuspendOn: html
	html form: [
		html text: 'UI Process is running. '.
		html submitButton
			callback: [ self suspend ];
			text: 'Suspend' ]! !

!WAVNCController methodsFor: 'actions' stamp: 'lr 11/21/2006 00:02'!
resume
	self project uiProcess resume! !

!WAVNCController methodsFor: 'accessing' stamp: 'pmm 3/6/2007 21:51'!
serverClass
	^ Smalltalk classNamed: #RFBServer! !

!WAVNCController methodsFor: 'accessing' stamp: 'pmm 3/6/2007 21:53'!
serverInstance
	^ self serverClass server! !

!WAVNCController methodsFor: 'actions' stamp: 'pmm 3/6/2007 21:56'!
startOn: aNumber
	self resume.
	self serverClass start: aNumber! !

!WAVNCController methodsFor: 'actions' stamp: 'pmm 3/6/2007 21:56'!
stop
	self serverClass stop! !

!WAVNCController methodsFor: 'actions' stamp: 'lr 11/21/2006 00:02'!
suspend
	self project uiProcess suspend.
	self stop! !

WAComponent subclass: #WAVersionUploader
	instanceVariableNames: 'file url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Squeak-Development-Core'!

!WAVersionUploader class methodsFor: 'accessing' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

!WAVersionUploader class methodsFor: 'accessing' stamp: 'lr 6/10/2007 20:27'!
description
	^ 'Monticello Browser'! !

!WAVersionUploader class methodsFor: 'initialization' stamp: 'lr 2/12/2007 21:52'!
initialize
	self registerAsApplication: 'tools/versionuploader'! !

!WAVersionUploader methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
loadFile
	| reader version |
	reader := MCVersionReader readerClassForFileNamed: file fileName.
	reader ifNil: [self inform: file fileName, ' is not in a known format'].
	version := reader versionFromStream: file contents asByteArray readStream.
	version load! !

!WAVersionUploader methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
loadURL
	| stream version |
	stream := url asUrl retrieveContents content asByteArray readStream .
	version := (MCVersionReader readerClassForFileNamed: url) versionFromStream: stream.
	version load! !

!WAVersionUploader methodsFor: 'actions' stamp: 'pmm 4/24/2008 07:19'!
newVersion: aWorkingCopy
	| version stream |
	version := [ aWorkingCopy newVersion ]
		on: MCVersionNameAndMessageRequest
		do: [ :request | request resume: (Array with: request suggestedName with: '') ].
	stream := RWBinaryOrTextStream on: String new.
	version fileOutOn: stream.
	self requestContext returnResponse: (WAResponse new
		contentType: 'application/octet-stream' toMimeType;
		attachmentWithFileName: version fileName;
		nextPutAll: stream contents;
		yourself)! !

!WAVersionUploader methodsFor: 'rendering' stamp: 'pmm 4/24/2008 07:00'!
renderContentOn: html
	self renderDownloadOn: html.
	self renderLoadFromFileOn: html.
	self renderLoadFromUrlOn: html.
	self renderSaveImageOn: html! !

!WAVersionUploader methodsFor: 'rendering' stamp: 'pmm 4/24/2008 07:08'!
renderDownloadOn: html
	html heading level2; with: 'Loaded versions'.
	html unorderedList
		with: [
			self sortedWorkingCopies do: [ :each |
				html listItem: [
					html text: each description.
					html space.
					html anchor
						callback: [ self newVersion: each ];
						with: 'Save' ] ] ]! !

!WAVersionUploader methodsFor: 'rendering' stamp: 'pmm 4/24/2008 07:06'!
renderLoadFromFileOn: html
	html heading level2; with: 'Load version from file'.
	html form
		multipart;
		with: [
			html fileUpload
				callback: [ :f | file := f ].
			html space.
			html submitButton
				callback: [ self loadFile ];
				text: 'Load' ].! !

!WAVersionUploader methodsFor: 'rendering' stamp: 'lr 5/31/2008 18:31'!
renderLoadFromUrlOn: html
	html heading level2; with: 'Load version from URL'.
	html form: [
		html textInput
			size: 60;
			value: 'http://'; callback: [ :u | url := u ].
		html space.
		html submitButton
			callback: [ self loadURL ];
			text: 'Load' ]! !

!WAVersionUploader methodsFor: 'rendering' stamp: 'pmm 4/24/2008 07:00'!
renderSaveImageOn: html
	html anchor
		callback:  [self saveImage ];
		with: 'Save Image'! !

!WAVersionUploader methodsFor: 'actions' stamp: 'pmm 1/26/2007 22:55'!
saveImage
	SmalltalkImage current snapshot: true andQuit: false! !

!WAVersionUploader methodsFor: 'accessing' stamp: 'pmm 4/24/2008 07:02'!
sortedWorkingCopies
	^MCWorkingCopy allManagers asSortedCollection: [ :a :b |
		a packageName <= b packageName ]! !

!WAVersionUploader methodsFor: 'updating' stamp: 'pmm 4/24/2008 07:03'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Version Uploader'! !

!TextMorphEditor methodsFor: '*seaside-squeak-development-core' stamp: 'jf 7/3/2008 17:57'!
evaluateSelection
	^ self withInterruptedProcessVariablesDo: [super evaluateSelection]! !

!TextMorphEditor methodsFor: '*seaside-squeak-development-core' stamp: 'jf 7/3/2008 17:57'!
tallySelection
	^ self withInterruptedProcessVariablesDo: [super tallySelection]! !

!TextMorphEditor methodsFor: '*seaside-squeak-development-core' stamp: 'jf 7/3/2008 17:57'!
withInterruptedProcessVariablesDo: aBlock
	| process m |
	process := nil.
	m := self morph.

	[process isNil and: [m notNil]] whileTrue:
		[(m model respondsTo: #interruptedProcess)
			ifTrue: [process := m model interruptedProcess]
			ifFalse: [m := m owner]].
	^ process isNil
		ifTrue: aBlock
		ifFalse: [WACurrentRequestContext
			use: (WACurrentRequestContext valueForProcess: process) 
			during: aBlock]! !

WAHaloPlugin subclass: #WABrowserHaloPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Squeak-Development-Core-Plugins'!

!WABrowserHaloPlugin commentStamp: 'pmm 5/27/2007 17:34' prior: 0!
I open a browser on the component class.!

!WABrowserHaloPlugin methodsFor: 'actions' stamp: 'lr 5/11/2007 13:57'!
execute
	EnableSeasideTools
		ifTrue: [ self open: (WABrowser fullOnClass: self target class) ]
		ifFalse: [ Browser fullOnClass: self target class ]! !

!WABrowserHaloPlugin methodsFor: 'accessing' stamp: 'lr 5/11/2007 00:54'!
label
	^ 'Browser'! !

!WABrowserHaloPlugin methodsFor: 'accessing' stamp: 'lr 5/11/2007 11:02'!
priority
	^ 500! !

!WABrowserHaloPlugin methodsFor: 'accessing' stamp: 'pmm 5/16/2007 16:24'!
tooltip
	^ 'Class Browser'! !

WATool subclass: #WAMemory
	instanceVariableNames: 'instances sizes table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Squeak-Development-Core'!

!WAMemory methodsFor: 'private' stamp: 'pmm 3/24/2008 16:40'!
buildTable
	^ WATableReport new
		rowPeriod: 1;
		rowPeriod: 1;
		rowColors: #( '#eee' 'white' );
		rows: sizes keys asSortedCollection;
		columns: (Array
			with: (WAReportColumn selector: #yourself title: 'Class')
			with: (WAReportColumn new
				title: 'Instances';
				valueBlock: [ :each | instances at: each ];
				sortBlock: [ :a :b | a > b ];
				cssClass: 'right';
				yourself)
			with: (WAReportColumn new
				title: 'Total Size';
				valueBlock: [ :each | sizes at: each ];
				sortBlock: [ :a :b | a > b ];
				formatBlock: [ :each | each asStringWithCommas ];
				cssClass: 'right';
				yourself));
		yourself! !

!WAMemory methodsFor: 'accessing' stamp: 'avi 2/10/2004 16:15'!
children
	^ Array with: table! !

!WAMemory methodsFor: 'initialization' stamp: 'lr 10/28/2007 14:42'!
initialize
	| segment results |
	super initialize.
	segment := ImageSegment new
		copyFromRoots: (Array with: self session)
		sizeHint: 100000.
	results := segment doSpaceAnalysis.
	instances := results first.
	sizes := results second.
	table := self buildTable! !

!WAMemory methodsFor: 'rendering' stamp: 'pmm 3/24/2008 13:25'!
renderContentOn: html
	html strong: self totalInstances toString, ' instances in ', self totalSizeString.
	html render: table! !

!WAMemory methodsFor: 'rendering' stamp: 'pmm 3/24/2008 16:41'!
style
	^'
strong {
	color: #444444;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 12px;
	margin: 2px
}

a, a:link, a:active, a:visited, a:focus, a:hover {
	color:#008AFF;
	font-family: Helvetica, Verdana, Arial, sans-serif;
	font-size: 12px;
}

table {
	border-collapse:collapse;
}

table td {
	font: 10pt Verdana, Arial, Helvetica, sans-serif;
	padding-left: 5px;
	padding-right: 5px;
}
	
.right {
	text-align: right;
}'
	! !

!WAMemory methodsFor: 'accessing' stamp: 'pmm 6/30/2007 00:01'!
totalInstances
	^ instances detectSum: [ :each | each ]! !

!WAMemory methodsFor: 'accessing' stamp: 'pmm 6/30/2007 00:01'!
totalSize
	^ sizes detectSum: [ :each | each ]! !

!WAMemory methodsFor: 'accessing' stamp: 'pmm 6/30/2007 00:04'!
totalSizeString
	|size unit|
	size := self totalSize.
	unit := 'bytes'.
	size > 1024 ifTrue: [
		size := size / 1024.
		unit := 'KiB'.
		size > 1024 ifTrue: [
			size := size / 1024.
			unit := 'MiB' ] ].
	^ (size printShowingDecimalPlaces: 1), ' ', unit! !

WATool subclass: #WAProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Squeak-Development-Core'!

!WAProfiler methodsFor: 'rendering' stamp: 'pmm 1/26/2007 21:34'!
children
	^Array with: self root! !

!WAProfiler methodsFor: 'private' stamp: 'pmm 2/23/2008 18:40'!
profileSendsDuring: aBlock
	| newPage report |
	newPage := Character value: 12.
	Processor activeProcess priority: 20.
	Smalltalk garbageCollectMost.
	report := String streamContents: [ :stream | 
		MessageTally new
			spyEvery: 1
			on: [ aBlock value. Smalltalk garbageCollectMost ];
			report: stream ].
	report keysAndValuesDo: [ :index :each | 
		each = newPage ifTrue: [
			report at: index put: Character space ] ].
	^ report! !

!WAProfiler methodsFor: 'rendering' stamp: 'pmm 6/30/2007 00:08'!
renderContentOn: html
	| profile |
	profile := self profileSendsDuring: [ html render: self root ].
	html horizontalRule.
	html preformatted: profile! !
WABrowser initialize!
WAScreenshot initialize!
WAVNCController initialize!
WAVersionUploader initialize!
